namespace Adaptation.FileHandlers.TIBCO.Transport;

/// <summary>
/// EDA-Configurator.pdf
/// CDS Namespace Reply Variables
/// </summary>
public class Logistics
{

    /// <summary>
    /// Basic Type
    /// </summary>
    public string BASIC_TYPE { get; set; }

    /// <summary>
    /// Text for additional information
    /// </summary>
    public string INFO { get; set; }

    /// <summary>
    /// Unique assignment of lot processing to the basic cell (Dresden)
    /// </summary>
    public string JOBID { get; set; }

    /// <summary>
    /// Equipment name used in MES
    /// </summary>
    public string MES_ENTITY { get; set; }

    /// <summary>
    /// Lot number, name for a lot
    /// </summary>
    public string MID { get; set; }

    /// <summary>
    /// Recipe (Process Program ID)
    /// </summary>
    public string PPID { get; set; }

    /// <summary>
    /// Process group (e.g. C5PR)
    /// </summary>
    public string PROCESS_GROUP { get; set; }

    /// <summary>
    /// Product name
    /// </summary>
    public string PRODUCT { get; set; }

    /// <summary>
    /// Total number of wafers in lot
    /// </summary>
    public string TOTAL_NUMBER_OF_WAFERS { get; set; }

    /// <summary>
    /// Equipment sequence number
    /// </summary>
    public string SEQUENCE { get; set; }

    /// <summary>
    /// Unique wafer number (barcode, OCR)
    /// </summary>
    public string WAFER_ID { get; set; }

    /// <summary>
    /// Wafer position in a tube (Furnace)
    /// </summary>
    public string WAFER_POS { get; set; }

}